//+------------------------------------------------------------------+
//|                                                 TradeControl.mq5 |
//|                                             Copyright KlimMalgin |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "KlimMalgin"
#property link      ""
#property version   "1.00"


datetime start_date = 0;   //      

int OrdersPrev = 0;        //        OnTrade()
int PositionsPrev = 0;     //        OnTrade()
ulong LastOrderTicket = 0; //        

int _GetLastError=0;       //   
long state=0;              //    

/*
 *
 *      
 *
 */
struct _position
{

long     type,          //  
         magic;         // Magic number  
datetime time;          //   

double   volume,        //  
         priceopen,     //  
         sl,            //  Stop Loss   
         tp,            //  Take Profit   
         pricecurrent,  //    
         comission,     // 
         swap,          //  
         profit;        //  

string   symbol,        // ,    
         comment;       //   
};

int _ExpertPositionsTotal = 0;

_position PositionList[],     //      
          PrevPositionList[];


/*
 *
 *      
 *
 */
struct _orders
{

datetime time_setup,       //   
         time_expiration,  //   
         time_done;        //     
         
long     type,             //  
         state,            //  
         type_filling,     //    
         type_time,        //   
         ticket;           //  
         
long     magic,            //     
                           // (  ,    
                           //     )
                           
         position_id;      //  ,     
                           //   .     
                           // ,        
                           // .      
                           //     .
                           
double volume_initial,     //     
       volume_current,     //  
       price_open,         // ,   
       sl,                 //  Stop Loss
       tp,                 //  Take Profit
       price_current,      //     
       price_stoplimit;    //   Limit    StopLimit 
       
string symbol,             // ,    
       comment;            // 
                           
};

int _ExpertOrdersTotal = 0;

_orders OrderList[],       //      
        PrevOrderList[];

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
start_date = 0;

OrdersPrev = OrdersTotal();
PositionsPrev = PositionsTotal();

GetPosition(PrevPositionList);
GetOrders(PrevOrderList);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| OnTrade function                                                 |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
GetPosition(PositionList);
GetOrders(OrderList);
datetime dc = TimeCurrent();
HistorySelect(start_date,dc);


Alert("  Trade");

if (OrdersPrev < OrdersTotal())
{
   OrderGetTicket(OrdersTotal()-1);//     
   _GetLastError=GetLastError();
   Print("Error #",_GetLastError);ResetLastError();
   //--
   if (OrderGetInteger(ORDER_STATE) == ORDER_STATE_STARTED)
   {
      Alert(OrderGetTicket(OrdersTotal()-1),"   ");
      LastOrderTicket = OrderGetTicket(OrdersTotal()-1);    //      
   }
   
   
   state = OrderGetInteger(ORDER_STATE);
   if (state == ORDER_STATE_PLACED)
   {
      switch(OrderGetInteger(ORDER_TYPE))
      {
         case 2:
            Alert("  buy limit ", OrderGetTicket(OrdersTotal()-1)," !");
         break;
         
         case 3:
            Alert("  sell limit ", OrderGetTicket(OrdersTotal()-1)," !");
         break;
         
         case 4:
            Alert("  Buy Stop ", OrderGetTicket(OrdersTotal()-1)," !");
         break;
         
         case 5:
            Alert("  Sell Stop ", OrderGetTicket(OrdersTotal()-1)," !");
         break;
         
         case 6:
            Alert("  Buy Stop Limit ", OrderGetTicket(OrdersTotal()-1)," !");
         break;
                 
         case 7:
            Alert("  Sell Stop Limit  ", OrderGetTicket(OrdersTotal()-1)," !");
         break;         
      }
      
   }
   
   
   
}
else if(OrdersPrev > OrdersTotal())
{
   state = HistoryOrderGetInteger(LastOrderTicket,ORDER_STATE);

   //      
   _GetLastError=GetLastError();
   if (_GetLastError != 0){Alert(" ",_GetLastError,"  ",LastOrderTicket,"  !");LastOrderTicket = 0;}
   Print("Error #",_GetLastError," state: ",state);ResetLastError();


   //    
   if (state == ORDER_STATE_FILLED)
   {
      //    
      // --
      Alert(LastOrderTicket, " ,   ");
      switch(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_ENTRY))
      {
         
         //   
         case DEAL_ENTRY_IN:
         Alert(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_ORDER), "    ",HistoryDealGetTicket(HistoryDealsTotal()-1));
         
            switch(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE))
            {
               case 0:
               //      ,      
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) && (PositionGetDouble(POSITION_VOLUME) == HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_VOLUME)))
                  {
                     Alert("  buy   ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)); 
                  }
                  else
               //      ,    
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) && (PositionGetDouble(POSITION_VOLUME) > HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_VOLUME)))
                  {
                     Alert("  buy   ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)); 
                  }
               break;
               
               case 1:
               //      ,      
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) && (PositionGetDouble(POSITION_VOLUME) == HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_VOLUME)))
                  {
                     Alert("  sell   ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)); 
                  }
                  else
               //      ,    
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) && (PositionGetDouble(POSITION_VOLUME) > HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_VOLUME)))
                  {
                     Alert("  sell   ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)); 
                  }
                  
               break;
               
               default:
                  Alert("  : ",
                        HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE));
               break;
            }
         break;
         
         //   
         case DEAL_ENTRY_OUT:
         Alert(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_ORDER), "    ",HistoryDealGetTicket(HistoryDealsTotal()-1));
         
            switch(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE))
            {
               case 0:
               //  ,    ,     
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) == true)
                  {
                     Alert("   sell   ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                           "   = ",
                           HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT));
                  }
                  else
               //    ,    
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) == false)
                  {
                     Alert("  sell   ",
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                           "   = ",
                           HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT));
                  }
               break;
               
               case 1:
               //  ,    ,     
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) == true)
                  {
                     Alert("   buy   ", 
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                           "   = ",
                           HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT));
                  }
                  else
               //    ,    
                  if (PositionSelect(HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL)) == false)
                  {
                     Alert("  buy   ",
                           HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                           "   = ",
                           HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT));
                  }
                  
               break;
               
               default:
                  Alert("  : ",
                        HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE));
               break;
            }
         break;
         
         // 
         case DEAL_ENTRY_INOUT:
         Alert(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_ORDER), "    ",HistoryDealGetTicket(HistoryDealsTotal()-1));
         
            switch(HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE))
            {
               case 0:
                  Alert("Sell   Buy   ",
                        HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                        "    = ",
                        HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT)); 
               break;
               
               case 1:
                  Alert("Buy   Sell   ",
                        HistoryDealGetString(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_SYMBOL),
                        "    = ",
                        HistoryDealGetDouble(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_PROFIT)); 
               break;
               
               default:
                  Alert("  : ",
                        HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE));
               break;
            }
         break;
         
         //   
         case DEAL_ENTRY_STATE:
            Alert("  .   : ", HistoryDealGetInteger(HistoryDealGetTicket(HistoryDealsTotal()-1),DEAL_TYPE));
         break;
      }
      // --
   }
   
}


if ((PositionsPrev == PositionsTotal()) && (OrdersPrev == OrdersTotal()))
{
   string _alerts = "";
   bool modify = false;
   
   for (int i=0;i<_ExpertPositionsTotal;i++)
   {
      if (PrevPositionList[i].sl != PositionList[i].sl)
      {
         _alerts += "  "+PositionList[i].symbol+"  stoploss  "+ PrevPositionList[i].sl +"  "+ PositionList[i].sl +"\n";
         modify = true;
      }
      if (PrevPositionList[i].tp != PositionList[i].tp)
      {
         _alerts += "  "+PositionList[i].symbol+"  takeprofit  "+ PrevPositionList[i].tp +"  "+ PositionList[i].tp +"\n";
         modify = true;
      }
      
   }
   
   for (int i = 0;i<_ExpertOrdersTotal;i++)
   {
      if (PrevOrderList[i].sl != OrderList[i].sl)
      {
         _alerts += "  "+OrderList[i].ticket+"  stoploss  "+ PrevOrderList[i].sl +"  "+ OrderList[i].sl +"\n";
         modify = true;
      }
      if (PrevOrderList[i].tp != OrderList[i].tp)
      {
         _alerts += "  "+OrderList[i].ticket+"  takeprofit  "+ PrevOrderList[i].tp +"  "+ OrderList[i].tp +"\n";
         modify = true;
      }
   }
   
   if (modify == true)
   {
      Alert(_alerts);
      modify = false;
   }
}


GetPosition(PrevPositionList);
GetOrders(PrevOrderList);
OrdersPrev = OrdersTotal();
PositionsPrev = PositionsTotal();

//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+



void GetPosition(_position &Array[])
  {
   int _GetLastError=0,_PositionsTotal=PositionsTotal();

   int temp_value=(int)MathMax(_PositionsTotal,1);
   ArrayResize(Array, temp_value);

   _ExpertPositionsTotal=0;
   for(int z=_PositionsTotal-1; z>=0; z--)
     {
      if(!PositionSelect(PositionGetSymbol(z)))
        {
         _GetLastError=GetLastError();
         Print("OrderSelect() - Error #",_GetLastError);
         continue;
        }
      else
        {
            //   ,       
            Array[z].type = PositionGetInteger(POSITION_TYPE);
            Array[z].time = PositionGetInteger(POSITION_TIME);
            Array[z].magic = PositionGetInteger(POSITION_MAGIC);
            Array[z].volume = PositionGetDouble(POSITION_VOLUME);
            Array[z].priceopen = PositionGetDouble(POSITION_PRICE_OPEN);
            Array[z].sl = PositionGetDouble(POSITION_SL);
            Array[z].tp = PositionGetDouble(POSITION_TP);
            Array[z].pricecurrent = PositionGetDouble(POSITION_PRICE_CURRENT);
            Array[z].comission = PositionGetDouble(POSITION_COMMISSION);
            Array[z].swap = PositionGetDouble(POSITION_SWAP);
            Array[z].profit = PositionGetDouble(POSITION_PROFIT);
            Array[z].symbol = PositionGetString(POSITION_SYMBOL);
            Array[z].comment = PositionGetString(POSITION_COMMENT);
        _ExpertPositionsTotal++;
        }
     }

   temp_value=(int)MathMax(_ExpertPositionsTotal,1);
   ArrayResize(Array,temp_value);
  }
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| Function GetOrders()                                             |
//+------------------------------------------------------------------+
void GetOrders(_orders &OrdersList[])
  {
   
   int _GetLastError=0,_OrdersTotal=OrdersTotal();

   int temp_value=(int)MathMax(_OrdersTotal,1);
   ArrayResize(OrdersList,temp_value);

   _ExpertOrdersTotal=0;
   for(int z=_OrdersTotal-1; z>=0; z--)
     {
      if(!OrderGetTicket(z))
        {
         _GetLastError=GetLastError();
         Print("GetOrders() - Error #",_GetLastError);
         continue;
        }
      else
        {
        OrdersList[z].ticket = OrderGetTicket(z);
        OrdersList[z].time_setup = OrderGetInteger(ORDER_TIME_SETUP);
        OrdersList[z].time_expiration = OrderGetInteger(ORDER_TIME_EXPIRATION);
        OrdersList[z].time_done = OrderGetInteger(ORDER_TIME_DONE);
        OrdersList[z].type = OrderGetInteger(ORDER_TYPE);
        
        OrdersList[z].state = OrderGetInteger(ORDER_STATE);
        OrdersList[z].type_filling = OrderGetInteger(ORDER_TYPE_FILLING);
        OrdersList[z].type_time = OrderGetInteger(ORDER_TYPE_TIME);
        OrdersList[z].magic = OrderGetInteger(ORDER_MAGIC);
        OrdersList[z].position_id = OrderGetInteger(ORDER_POSITION_ID);
        
        OrdersList[z].volume_initial = OrderGetDouble(ORDER_VOLUME_INITIAL);
        OrdersList[z].volume_current = OrderGetDouble(ORDER_VOLUME_CURRENT);
        OrdersList[z].price_open = OrderGetDouble(ORDER_PRICE_OPEN);
        OrdersList[z].sl = OrderGetDouble(ORDER_SL);
        OrdersList[z].tp = OrderGetDouble(ORDER_TP);
        OrdersList[z].price_current = OrderGetDouble(ORDER_PRICE_CURRENT);
        OrdersList[z].price_stoplimit = OrderGetDouble(ORDER_PRICE_STOPLIMIT);
        
        OrdersList[z].symbol = OrderGetString(ORDER_SYMBOL);
        OrdersList[z].comment = OrderGetString(ORDER_COMMENT);
        
        _ExpertOrdersTotal++;
        }
     }

   temp_value=(int)MathMax(_ExpertOrdersTotal,1);
   ArrayResize(OrdersList,temp_value);

  }
//+------------------------------------------------------------------+